/* bankmove.c compile as a ttp program using Mark Johnson 'C' */
/* from public domain */

/* (c) C.J.Rogers 1989. Not released for public domain, yet */


#include        <c:\compiler\stdio.h>

int *fd;
unsigned char message[256];  /* prepared message for midiout */


main(argc,argv)
int argc;
char *argv[];
{
char *full_name;
full_name=*++argv;	/* name of bank passed as first parameter */
init_message();		/* set first four parts of a sys ex message */

	fd=fopen(full_name, "r");
       	if(fd==0)return(9);
printf("sending %s to MT32 please wait\n",full_name);
                      	
         tim_send();
         patch_send();
         rythm_send();
         sys_send();

fclose(fd);

}



calchk(k) /* calculate checksum byte k indicates bytes of info excluding header and checksum etc. */
int k;
{
int a;
int chksum;
int total;
total=0;
for(a=5;a<k;a++)
     {
      total=total+message[a];
     }
do
 if(total>-1)total=total-128;
while (total>-1);

chksum=total*(-1);
return chksum;
}


init_message()
{
message[0]=240; /* set up standard parts of message */
message[1]=65;
message[2]=16;
message[3]=22;
message[4]=18;
}


rythm_send()
{
int a;
int b;
unsigned char val[128];


for(b=1;b<3;b++)
  {
     message[5]=3;
     if(b==1){message[6]=1;}else{message[6]=2;}
     message[7]=16;

     fread(val,128,1,fd);

     for(a=0;a<128;a++){
		        message[(a+8)]=val[a];
                       }

          send_dat(128);
  }
}

sys_send()
{
int c, a;
unsigned char val[23];
     message[5]=16;   /* start address MSB */
     message[6]=0;
     message[7]=0;

     fread(val,23,1,fd);

     for(a=0;a<23;a++){
     message[(a+8)]=val[a];
                       }

          send_dat(23);

}


patch_send()
{
int c, a;
unsigned char val[128];


for(c=0;c<8;c++){
     message[5]=5;    /* start address MSB */
     message[6]=c;
     message[7]=0;
     fread(val,128,1,fd);

     for(a=0;a<128;a++){
     message[(a+8)]=val[a];
                       }

          send_dat(128);
                 }
}


tim_send()
{
int c, a;
unsigned char val[246];

for(c=0;c<64;c++){
     message[5]=8;    /* start address MSB */
     message[6]=(c*2);/* timbre memory no */
     message[7]=0;

     fread(val,246,1,fd);

     for(a=0;a<246;a++){
     message[(a+8)]=val[a];
                       }

          send_dat(246);
                 }

}

send_dat(k)
int k;
{
int a;
message[(k+8)]=calchk(k+8);
message[(k+9)]=247;

     for(a=0;a<(k+10);a++){
          trap(13,3,3,message[a]);
                         }

}
